/* 
 * Copyright (C) 2009 RDC Semiconductor Co.,Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * For technical support : 
 *     <jason.lin@rdc.com.tw>
 */

/* internal functions prototype */
void SetVBERerurnStatus(WORD VBEReturnStatus, CBIOS_ARGUMENTS *pCBiosArguments);

void SetTimingRegs(UCHAR ucDisplayPath, MODE_INFO *pModeInfo, RRATE_TABLE *pRRateTable);
void SetHTotal(BYTE DisplayPath, WORD Value);
void SetHDisplayEnd(BYTE DisplayPath, WORD Value);
void SetHBlankingStart(BYTE DisplayPath, WORD Value);
void SetHBlankingEnd(BYTE DisplayPath, WORD Value);
void SetHSyncStart(BYTE DisplayPath, WORD Value);
void SetHSyncEnd(BYTE DisplayPath, WORD Value);
void SetVTotal(BYTE DisplayPath, WORD Value);
void SetVDisplayEnd(BYTE DisplayPath, WORD Value);
void SetVBlankingStart(BYTE DisplayPath, WORD Value);
void SetVBlankingEnd(BYTE DisplayPath, WORD Value);
void SetVSyncStart(BYTE DisplayPath, WORD Value);
void SetVSyncEnd(BYTE DisplayPath, WORD Value);
void SetPixelClock(BYTE DisplayPath, DWORD Clock);
void SetHSource(BYTE bDisplayPath, WORD wValue);
PLL_Info ClockToPLLF9003A(DWORD Clock);
void SetDPLL(BYTE DisplayPath, PLL_Info PLLInfo);
void SetPolarity(BYTE DevicePort, BYTE Value);
void SetFIFO(BYTE DisplayPath);
void SetPitch(BYTE DisplayPath, WORD Value);
WORD GetPitch(BYTE DisplayPath);
WORD GetVDisplayEnd(BYTE DisplayPath);
void SetColorDepth(BYTE DisplayPath, BYTE Value);
void ConfigDigitalPort(BYTE bDisplayPath);
void LoadTiming(BYTE DisplayPath, WORD ModeNum);
void LoadVESATiming(BYTE bDisplayPath, WORD wModeNum);
void LoadLCDTiming(BYTE bDisplayPath, WORD wModeNum);
void SetScalingFactor(BYTE bDisplayPath, MODE_INFO *pUserModeInfo, MODE_INFO *pPanelModeInfo);
void SetHorScalingFactor(BYTE bDisplayPath, WORD wValue);
void SetVerScalingFactor(BYTE bDisplayPath, WORD wValue);
CI_STATUS isLCDFitMode(BYTE bDeviceIndex, WORD wModeNum);
CI_STATUS GetModePointerFromVESATable(WORD wModeNum, BYTE bRRIndex, MODE_INFO **ppModeInfo, RRATE_TABLE **ppRRateTable);
CI_STATUS GetModePointerFromLCDTable(BYTE bDeviceIndex, MODE_INFO **ppModeInfo, PANEL_TABLE **ppPanelTable);
CI_STATUS Get_MODE_INFO(WORD wModeNum, MODE_INFO **ppModeInfo);
CI_STATUS Get_MODE_INFO_From_LCD_Table(BYTE bDeviceIndex, MODE_INFO **ppModeInfo);
CI_STATUS Get_MODE_INFO_From_VESA_Table(WORD wModeNum, MODE_INFO **ppModeInfo);
CI_STATUS GetModeColorDepth(WORD wModeNum, MODE_INFO *pModeInfo, BYTE *pbColorDepth);

CI_STATUS GetModePitch(WORD ModeNum, WORD *pPitch);
WORD ReadRegFromHW(REG_OP *pRegOp);
void WriteRegToHW(REG_OP *pRegOp, WORD value);
void UnLockCR0ToCR7();
void LockCR0ToCR7();
CI_STATUS CheckForModeAvailable(WORD ModeNum);
CI_STATUS CheckForNewDeviceAvailable(BYTE bDeviceIndex);
void Display1TurnOnTX();
void Display1TurnOffTX();
void Display2TurnOnTX();
void Display2TurnOffTX();
void TurnOnDigitalPort(BYTE bDeviceIndex);
void TurnOffDigitalPort(BYTE bDeviceIndex);
BYTE GetPortConnectPath(BYTE PortType);
WORD TransDevIDtoBit(BYTE DeviceIndex);
void TurnOnCRTPad();
void TurnOffCRTPad();
void TurnOnDVP1Pad();
void TurnOffDVP1Pad();
void TurnOnDVP2Pad();
void TurnOffDVP2Pad();
void TurnOnDVP12Pad();
void TurnOffDVP12Pad();
void TurnOnScaler(BYTE bDisplayPath);
void TurnOffScaler(BYTE bDisplayPath);
void TurnOnHorScaler(BYTE bDisplayPath);
void TurnOffHorScaler(BYTE bDisplayPath);
void TurnOnVerScaler(BYTE bDisplayPath);
void TurnOffVerScaler(BYTE bDisplayPath);

void Set12BitDVP();
void Set24BitDVP();
void TurnOnDAC();
void TurnOffDAC();
void SerialLoadTable(UCHAR **ppucDisplay1VESAModeInitRegs, UCHAR ucI2Cport, UCHAR ucI2CAddr);
void SerialLoadRegBits(UCHAR **ppucDisplay1VESAModeInitRegs, UCHAR ucRegGroup, UCHAR ucI2Cport, UCHAR ucI2CAddr);
void SerialLoadReg(UCHAR **ppucDisplay1VESAModeInitRegs, UCHAR ucRegGroup, UCHAR ucI2Cport, UCHAR ucI2CAddr);
void LoadDisplay1VESAModeInitRegs();
void VESASetBIOSData(WORD ModeNum);
void DisableDisplayPathAndDevice(BYTE DisplayPath);
CI_STATUS GetDevicePortConfig(BYTE bDeviceIndex, PORT_CONFIG **ppPortConfig);
void PowerSequenceOn();
void PowerSequenceOff();
void SequencerOn(BYTE DisplayPath);
void SequencerOff(BYTE bDisplayPath);
void ControlPwrSeqOn(BYTE bDeviceIndex);
void ControlPwrSeqOff(BYTE bDeviceIndex);
void LongWait();
BYTE Get_DEV_ID(BYTE DisplayPath);
void Set_DEV_ID(BYTE DeviceID, BYTE DisplayPath);
BYTE Get_NEW_DEV_ID(BYTE DisplayPath);
void Set_NEW_DEV_ID(BYTE DeviceID, BYTE DisplayPath);
WORD Get_LCD_H_SIZE();
WORD Get_LCD_V_SIZE();
DWORD Get_LCD_SIZE();
WORD Get_LCD2_H_SIZE();
WORD Get_LCD2_V_SIZE();
DWORD Get_LCD2_SIZE();
BYTE Get_RRATE_ID(BYTE DisplayPath);
void Set_RRATE_ID(BYTE RRateID, BYTE DisplayPath);
BYTE Get_LCD_TABLE_INDEX(void);
BYTE Get_LCD2_TABLE_INDEX(void);
void Set_LCD_TABLE_INDEX(BYTE bLCDIndex);
WORD Get_VESA_MODE(BYTE DisplayPath);
void Set_VESA_MODE(WORD ModeNum, BYTE DisplayPath);
void ResetATTR();
void EnableATTR();
void SetCRReg(BYTE bRegIndex, BYTE bRegValue, BYTE bMask);
BYTE GetCRReg(BYTE bRegIndex);
void SetSRReg(BYTE bRegIndex, BYTE bRegValue, BYTE bMask);
BYTE GetSRReg(BYTE bRegIndex);
void SetARReg(BYTE index,BYTE value);
BYTE GetARReg(BYTE index);
void SetGRReg(BYTE bRegIndex, BYTE bRegValue, BYTE bMask);
void SetMSReg(BYTE bRegValue);
BYTE GetIS1Reg();
void ClearFrameBuffer(BYTE DisplayPath,DWORD *pFrameBufferBase,MODE_INFO *pModeInfo, BYTE bColorDepth);
DWORD Difference(DWORD Value1, DWORD Value2);
BYTE ReadScratch(WORD IndexMask);
void WriteScratch(WORD IndexMask, BYTE Data);
BYTE AlignDataToLSB(BYTE bData, BYTE bMask);
BYTE AlignDataToMask(BYTE bData, BYTE bMask);
void SetDPMS(BYTE DPMSState, BYTE DisplayPath);
CI_STATUS DetectMonitor();
void WaitDisplayPeriod();
void WaitPowerSequenceDone();
CI_STATUS CheckForDSTNPanel(BYTE bDeviceIndex);
WORD GetVESAMEMSize();
void SetDeviceSupport();

