/* 
 * Copyright (C) 2009 RDC Semiconductor Co.,Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * For technical support : 
 *     <jason.lin@rdc.com.tw>
 */

/* Mode Limitation */
#ifdef FPGA
#define MAX_HResolution     1024
#define MAX_VResolution     768
#else
#define MAX_HResolution     1920
#define MAX_VResolution     1200
#endif
 
/* Std. Table Index Definition */
#define TextModeIndex       0
#define EGAModeIndex        1
#define VGAModeIndex        2
#define HiCModeIndex        3
#define TrueCModeIndex      4

/* DCLK Index */
#define VCLK25_175          0x00
#define VCLK28_322          0x01
#define VCLK31_5            0x02
#define VCLK36              0x03
#define VCLK40              0x04
#define VCLK49_5            0x05
#define VCLK50              0x06
#define VCLK56_25           0x07
#define VCLK65              0x08
#define VCLK75              0x09
#define VCLK78_75           0x0A
#define VCLK94_5            0x0B
#define VCLK108             0x0C
#define VCLK135             0x0D
#define VCLK157_5           0x0E
#define VCLK162             0x0F
/* #define VCLK193_25           0x10 */
#define VCLK154             0x10

/* Flags Definition */
#define Charx8Dot           0x00000001
#define HalfDCLK            0x00000002
#define DoubleScanMode      0x00000004
#define LineCompareOff      0x00000008
#define SyncPP              0x00000000
#define SyncPN              0x00000040
#define SyncNP              0x00000080
#define SyncNN              0x000000C0
#define HBorder             0x00000020
#define VBorder             0x00000010

/* DAC Definition */
#define DAC_NUM_TEXT        64
#define DAC_NUM_EGA         64
#define DAC_NUM_VGA         256

/* DisplayModePtr->PrivFlags */
#define LCD_TIMING          0x00010000

/* Data Structure decalration for internal use */
typedef struct {
    UCHAR   MISC;
    UCHAR   SEQ[4];
    UCHAR   CRTC[25];
    UCHAR   AR[20];
    UCHAR   GR[9];
    
} VBIOS_STDTABLE_STRUCT, *PVBIOS_STDTABLE_STRUCT;

typedef struct {
    UCHAR   ucNS;
    UCHAR   ucMS;
    UCHAR   ucRS;
} VBIOS_DCLK_INFO, *PVBIOS_DCLK_INFO;

typedef struct _RRateInfo{
    float fRefreshRate;
    Bool  BInterlaced;
    UCHAR ucRRateIndex;
}RRateInfo;

typedef struct _MODE_PRIVATE
{
    USHORT  Mode_ID_8bpp;
    USHORT  Mode_ID_16bpp;
    USHORT  Mode_ID_32bpp;
    UCHAR   ucRRate_ID;
} MODE_PRIVATE;


